---
title: WEBGL_debug_shaders.getTranslatedShaderSource()
slug: Web/API/WEBGL_debug_shaders/getTranslatedShaderSource
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_debug_shaders.getTranslatedShaderSource()</strong></code> method is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and allows you to debug a translated shader.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">gl.getExtension('WEBGL_debug_shaders').getTranslatedShaderSource(shader);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>shader</dt>
 <dd>A {{domxref("WebGLShader")}} to get the translated source from.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("String")}} containing the translated shader source. An empty string is returned, if:</p>

<ul>
 <li>no source has been defined or,</li>
 <li>{{domxref("WebGLRenderingContext.compileShader()")}} has not yet been called or,</li>
 <li>the translation for the shader failed.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var canvas = document.getElementById('canvas');
var gl = canvas.getContext('webgl');

var shader = gl.createShader(gl.FRAGMENT_SHADER);
gl.shaderSource(shader, 'void main() { gl_FragColor = vec4(gl_FragCoord.x, 0.0, 0.0, 1.0); }');
gl.compileShader(shader);

var src = gl.getExtension('WEBGL_debug_shaders').getTranslatedShaderSource(shader);
console.log(src);
// "void main(){
// (gl_FragColor = vec4(gl_FragCoord.x, 0.0, 0.0, 1.0));
// }"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_debug_shaders', "", "WEBGL_debug_shaders.getTranslatedShaderSource")}}</td>
   <td>{{Spec2('WEBGL_debug_shaders')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_debug_shaders.getTranslatedShaderSource")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLShader")}}</li>
 <li>{{domxref("WebGLRenderingContext.compileShader()")}}</li>
</ul>
